#!/usr/local/dist/bin/gawk -f

# Usage: generate_auto_new.awk CLASS_FILES PROTOCOL_FILES
#
# Copyright 2001 Stephan Schulz, schulz@informatik.tu-muenchen.de
#
# Replace find_optimal.awk and generate_auto[2].awk in one hopefully
# much more efficient 
#

BEGIN{
   if(!ARGV[1])
   {
      print "Usage: filter_results.awk <filter_file> [<from_file>]";
      exit 1;
   }
   if(!ARGV[2])
   {
      ARGV[2] = "-";
      ARGC++;
   }   
}


function get_basename(name,     tmp)
{
   if(!match(name, /[A-Z]*[0-9]*[+-][0-9]*(\.[0-9]+)?/))
   {
      print "filter_results.awk: Cannot find problem basename in '" name "'";
   }   
   return substr(name, RSTART , RLENGTH);
}


# Skipping comments

/^#/{
  next;
}

# Process all non-empty lines

/[A-Za-z0-9]+/{
   if(ARGIND == 1)
   {
      names[get_basename($0)] = 1;
   }
   else
   {
      if(names[get_basename($0)])
      {
	 print;
	 # delete names[get_basename($0)];
      }
   }
}

#END{
#   print "Remaining:";
#   for(i in names)
#   {
#      print i;
#   }
#}
